#ifndef LIBLEX_H
#define LIBLEX_H

/**
 * Represents a result of a liblex operation.
 */
enum liblex_result_e {
  /**
   * Represents a succesful operation.
   */
  LIBLEX_SUCCESS,
  /**
   * Represents a memory allocation failure.
   */
  LIBLEX_MALLOC,
  /**
   * Represents an invalid pattern.
   */
  LIBLEX_INVALID,
  /**
   * Represents an unrecognized token.
   */
  LIBLEX_UNRECOGNIZED
};

typedef enum liblex_result_e liblex_result;

#endif
